/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: RuleBase.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _TOPS_RULE_BASE_HPP_
#define _TOPS_RULE_BASE_HPP_

#include "tops/common/Printable.hpp"

#include "tops/utilities/Iterator/SharedToPointerIterator.hpp"

#include <list>
#include <set>

#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>

namespace tops {

	class ProductionRule;
	typedef boost::shared_ptr<ProductionRule> ProductionRulePtr;
	class Rule;
	typedef boost::shared_ptr<Rule> RulePtr;

	/**
	 * ルールベースです。
	 *
	 * @author トゥイー
	 */
	class RuleBase : public boost::noncopyable, public Printable {
		friend class ProductionRule;

	private:
		typedef std::set<std::string> NameSet;
		typedef std::list<ProductionRulePtr> Container;

		typedef NameSet::iterator nameIterator;
		typedef NameSet::const_iterator const_nameIterator;

		typedef Container::iterator InnerIterator;
		typedef Container::const_iterator ConstInnerIterator;

	public:
		typedef Utility::SharedToPointerIterator<InnerIterator, ProductionRule> iterator;
		typedef Utility::ConstSharedToPointerIterator<ConstInnerIterator, ProductionRule> const_iterator;

	private:
		/**
		 * プロダクションルールの名前列です。
		 */
		NameSet m_names;

		/**
		 * プロダクションルール列です。
		 */
		Container m_rules;

	public:
		/**
		 * ルールベースを破棄します。
		 */
		~RuleBase();

	private:
		ProductionRule* createProductionRule(const RulePtr& rule, nameIterator selfNameIterator);
		void removeProductionRule(nameIterator selfNameIterator, InnerIterator selfIterator);

	public:
		/**
		 * 空かどうかを判断します。
		 *
		 * @return 空だったらtrueを、空じゃなかったらfalseを返します。
		 */
		bool empty() const;

		/**
		 * サイズを取得します。
		 */
		size_t size() const;

		/**
		 * ルールを追加します。
		 */
		ProductionRule* add(const RulePtr& rule);

		iterator begin() {
			return m_rules.begin();
		}

		const_iterator begin() const {
			return m_rules.begin();
		}

		iterator end() {
			return m_rules.end();
		}

		const_iterator end() const {
			return m_rules.end();
		}

	public:
		/**
		 * 全てのプロダクションルールを削除します。
		 */
		void clear();

	public:
		/**
		 * ストリームに出力します。
		 */
		void print(std::ostream& stream) const;
	};

}  // namespace tops

#endif
